<template>
  <div class="app-container">
    <search-form/>
    <table-list
      :listLoading="listLoading"
      :data="tableData2"
      :columns="listConfig"
      :currentPage="currentPage"
      :pageSize="pageSize"
      :totalRecords="totalRecords"
      @currentChange="pageHandle"
      @sizeChange="sizeChange"
      :isAdd="true"
      @add="openPopup"
    />
    <dict-edit
      :isShow="isPopupShow"
      :curObj="curObj"
      @close="closePopup"
    />
  </div>
</template>
<script>
import { arrToObj } from '@/utils'
import SearchForm from './components/searchForm/DictDtl'
import DictEdit from './components/popup/DictDtlEdit'
import baseTable from '_m/baseTable.js'
export default {
  // name: 'basePublicDictSys',
  components: {
    SearchForm,
    DictEdit
  },
  provide () {
    return {
      parentData: this
    }
  },
  mixins: [baseTable],
  data () {
    return {
      apiStr: 'base.admdictdatalist',
      searchForm: null,
      isPopupShow: false,
      noCreated: true,
      curObj: {},
      curId: '',
      curType: '',
    }
  },
  computed: {
    tableData2 () {
      let arr = [...this.tableData]
      arr.map(item => {
        if (Number(item.system) === 1) item.nosys = true
      })
      return arr
    }
  },
  mounted () {
    this.listConfig = {
      rows: [
        { label: '排序', prop: 'dict_sort' },
        { label: '值', prop: 'dict_value' },
        { label: '名称', prop: 'dict_label' },
        { label: '自定义值1', prop: 'option1' },
        { label: '自定义值2', prop: 'option2' },
        { label: '说明', prop: 'remark' },
        { label: '更新人', prop: 'update_by' },
        { label: '更新时间', prop: 'update_at' },
        // { label: '状态', prop: 'status', type: 'tag', tags: arrToObj(this.$dictData.dictStatus), tagTypeObj: {'1': 'success', '2': 'danger'} },
        { label: '操作', width: 200, type: 'handle2',
          operations: [
            // { labelFor: 'status', disabled: true, func: this.statusHandle, hide: 'nosys',
            //   labelConfig: {
            //     texts: {
            //       1: '停用',
            //       2: '启用'
            //     },
            //     btnTypes: {
            //       1: 'danger',
            //       2: 'success'
            //     }
            //   }
            // },
            { label: '编辑', func: this.openPopup, btnType: 'primary' },
            { label: '删除', func: this.delHandle, btnType: 'danger', hide: 'nosys' },
          ]
        }
      ]
    }
    const query = this.$route.query
    if (query.dict_type) {
      this.curType = query.dict_type || ''
      this.searchForm = {
        dict_type: query.dict_type
      }
      this.fetchData()
    }
  },
  methods: {
    delHandle (row) {
      const msgHtml = `确定要删除此字典吗？`
      this.$msg(msgHtml, 'confirm', ()=> {
        this.$api.base.dictdatadel({
          data_id: row.id,
        }).then(data => {
          this.$msgs(`删除成功！`)
          this.fetchData()
        })
      }, null, true)
    },
    statusHandle (row) {
      const status = Number(row.status) === 1 ? 2 : 1
      const msgText = Number(row.status) === 1 ? '停用' : '启用'
      this.$msg(`确定要${msgText}该字典吗？`, 'confirm', ()=> {
        this.$api.base.dictupdate({
          id: row.id,
          status
        }).then(data => {
          this.$msgs(`${msgText}成功！`)
          this.fetchData()
        })
      }, null, true)
    },
    openPopup (row) {
      this.curObj = row || {}
      this.isPopupShow = true
    },
    closePopup (obj) {
      this.isPopupShow = false
      if (obj) {
        this.fetchData()
      }
    }
  }
}
</script>
